'+--------------------------------------------------------------------------+
'|                                 zSkin                                    |
'|                                                                          |
'|                  Set/Get the skin component properties.                  |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2007                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 08-17-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

'// Fast line input replacement section
TYPE OVERLAPPED
  Internal AS DWORD
  InternalHigh AS DWORD
  offset AS DWORD
  OffsetHigh AS DWORD
  hEvent AS DWORD
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS DWORD
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

%WINAPI                                         = 1
%NULL                                           = 0
%GENERIC_READ                                   = &H80000000&
%GENERIC_WRITE                                  = &H40000000&
%FILE_SHARE_READ                                = &H00000001
%FILE_SHARE_WRITE                               = &H00000002
%FILE_ATTRIBUTE_NORMAL                          = &H00000080
%INVALID_HANDLE_VALUE                           = &HFFFFFFFF???
%FILE_BEGIN                                     = 0
%FILE_FLAG_WRITE_THROUGH                        = &H080000000
%OPEN_ALWAYS                                    = 4
%FILE_TYPE_DISK                                 = &H1
%STD_OUTPUT_HANDLE                              = -11&
%MAX_PATH                                       = 260  ' max. length of full pathname

$Anti = "\"

'-----------------------------------------------------------------
' Declared Functions:  11
'-----------------------------------------------------------------
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" (lpFileName AS ASCIIZ, BYVAL dwDesiredAccess AS DWORD, BYVAL dwShareMode AS DWORD, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwCreationDisposition AS DWORD, _
                 BYVAL dwFlagsAndAttributes AS DWORD, BYVAL hTemplateFile AS DWORD) AS DWORD
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS DWORD
DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" (BYVAL hFile AS DWORD, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetFileType LIB "KERNEL32.DLL" ALIAS "GetFileType" (BYVAL hFile AS DWORD) AS LONG
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" (BYVAL nStdHandle AS DWORD) AS DWORD
DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS DWORD, lpNumberOfBytesRead AS DWORD, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" (BYVAL hFile AS DWORD, BYVAL lDistanceToMove AS LONG, lpDistanceToMoveHigh AS LONG, BYVAL dwMoveMethod AS DWORD) AS LONG
DECLARE FUNCTION WriteConsole LIB "KERNEL32.DLL" ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS DWORD, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG
DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" (BYVAL nStdHandle AS LONG) AS LONG
DECLARE FUNCTION WriteConsole LIB "KERNEL32.DLL" ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS LONG, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG

%STD_OUTPUT_HANDLE    = -11&

'// Full file detection.
FUNCTION zExist (zFileSpec AS ASCIIZ) AS LONG
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    IF LEN(zFileSpec) THEN
       hFind = FindFirstFile(zFileSpec, fd)
       IF hFind <> -1 THEN
          CALL FindClose(hFind&)
          FUNCTION = -1
       END IF
    END IF
END FUNCTION

' Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zSetBufinChar ALIAS "zSetBufinChar" (BYVAL Char$) STATIC EXPORT AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

' Generic open file function
FUNCTION zFOpen ALIAS "zFOpen"(zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) EXPORT AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = %INVALID_HANDLE_VALUE THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

' Dito LOF
FUNCTION zFlof ALIAS "zFlof" (BYVAL hFile AS LONG) EXPORT AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       LOCAL fSize AS LONG
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1 THEN FUNCTION = fSize
    END IF
END FUNCTION

' Dito SEEK
FUNCTION zFSeek ALIAS "zFSeek" (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) EXPORT AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL %NULL, %FILE_BEGIN) < 0 THEN
       FUNCTION = GetLastError
    END IF
END FUNCTION

' Dito GET
FUNCTION zFGet ALIAS "zFGet" (BYVAL hFile AS LONG, StringBuf AS STRING) EXPORT AS LONG
    IF hFile THEN
       LOCAL LenBuf, ByttesReaded AS LONG
       LenBuf = LEN(StringBuf)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(StringBuf), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

' GET at a specific offset
FUNCTION zFGetAt ALIAS "zFGetAt" (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, Buf$) EXPORT AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zFGet(hFile, Buf$)
    FUNCTION = nErrCode
END FUNCTION

' Dito CLOSE
SUB zFClose ALIAS "zFClose" (hFile AS LONG) EXPORT
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

' Enhanced sequential LINEINPUT
FUNCTION zBufin ALIAS "zBufin" (zFileName AS ASCIIZ, nDone AS LONG) STATIC EXPORT AS STRING
DIM sCr AS STRING, sBuffer AS STRING
DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
IF LEN(zFileName) THEN
   IF NOT nReading THEN
      sCr = zSetBufinChar("")           ' added for spec char
      nReading = -1: nDone = 0
      IF ASC(sCr) = 13 THEN             ' added for spec char
         nLenCr = 0: sCr = CHR$(13)
      ELSE                              ' added for spec char
         nLenCr = LEN(sCr)              ' added for spec char
      END IF                            ' added for spec char
      nCr = 0: nLocation = 0
      IF NOT zExist(zFileName) THEN GOTO BufEnd  ' Nothing to do
      nErrCode = zFOpen(zFileName, 0, 2, hFile)
      IF nErrCode THEN
         nDone = nErrCode: nReading = 0
         EXIT FUNCTION
      END IF
      nRemaining = zFlof(hFile)                  ' Bytes count to be read
      nSizeFile = nRemaining                     ' Remember this
      IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
      nBufSize = 16384
      sBuffer = SPACE$(nBufSize)
   END IF
   DO WHILE nRemaining                           ' While more in the file
      IF nCr = 0 THEN                            ' If no return was found
         IF nRemaining < nBufSize THEN           ' read only what remains.
            nBufSize = nRemaining                ' Resize the buffer.
            IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
            sBuffer = SPACE$(nBufSize)
         END IF
         nErrCode = zFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
         nLocation = nLocation + nBufSize        ' Here we are.
         nBufPos = 1                             ' Start at the beginning
      END IF                                     ' of that bloc.
      DO                                         ' Walk through buffer.
         nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
         IF nLenCr = 0 THEN                      ' Do this to read files with
            nLenCr = 1                           ' or without LF after CR.
            IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
         END IF
         IF nCr THEN                             ' We found one.
            nSaveCr = nCr                        ' Save where
            FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
            nBufPos = nCr + nLenCr               ' In case of LF skip it
            EXIT FUNCTION                        ' all done for now.
         ELSE                                    ' Back up in the file.
          ' If we reached the end of file and no nCr
          ' was found, return what remains in the string.
            IF nLocation >= nSizeFile THEN
             ' Assign function and trap ^Z
               FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
               nRemaining = nBufSize
               EXIT DO
            END IF
          ' 05-06-1998 () were missing on each side of (nLenCr - 1)
            nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
            nRemaining = nRemaining + nSlop           ' Calc file excess.
            nLocation = nLocation - nSlop
         END IF
      LOOP WHILE nCr                                 ' While more in buffer.
      nRemaining = nRemaining - nBufSize
      nSaveCr = 0
   LOOP
END IF

BufEnd:
nReading = 0: nDone = -1: CALL zFClose(hFile)
END FUNCTION

DECLARE FUNCTION GetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "GetCurrentDirectoryA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
' Returns current Disk and Path
SUB zDskPath(Dsk$, Path$)
'   Dsk$ and Path$ are ready to be concatened with a filename
'   Dsk$ and Paths correspond to the current directory
    LOCAL zTmp AS ASCIIZ * 260
    IF GetCurrentDirectory(BYVAL SIZEOF(zTmp), zTmp) THEN
       Dsk$ = LEFT$(zTmp, 2)
       Path$ = RTRIM$(MID$(zTmp, 3), ANY CHR$(0,92)) + $Anti
    END IF
END SUB

' Splits a full path name, and return the current disk and directory
SUB zSplitN (BYVAL FullName$, PathName$, FilName$)
' If no path is specified then the current directory is being used.
    PathName$ = "": FilName$ = ""
    Length& = LEN(FullName$)
    IF Length& THEN
       CALL zDskPath(Dsk$, ThisPath$): FilName$ = FullName$
       So& = INSTR(-1, FullName$, $Anti)
       IF So& THEN
          PathName$ = LEFT$(FullName$, So&)
       ELSE
          So& = INSTR(FullName$, ":")
       END IF
       IF PathName$ = Dsk$ OR LEN(PathName$) = 0 THEN
          PathName$ = Dsk$ + ThisPath$
       END IF
       IF So& THEN FilName$ = MID$(FullName$, So& + 1, Length& - So&)
    END IF
END SUB

DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" (BYVAL hModule AS DWORD, lpFileName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
FUNCTION zExeName () AS STRING
    LOCAL zTmp AS ASCIIZ * 260
    LenExeName& = GetModuleFileName(BYVAL %NULL, zTmp, SIZEOF(zTmp))
    IF LenExeName& THEN
       LenExeName& = MIN&(LenExeName&, SIZEOF(zTmp))
       FUNCTION = LEFT$(zTmp, LenExeName&)
    END IF
END FUNCTION

FUNCTION zSkinARGB(BYVAL sBF AS STRING) AS LONG
    DIM bytestruct AS COLORBYTES
    DIM result AS COLORLONG
    bytestruct.A = VAL(PARSE$(sBF, 2))
    bytestruct.R = VAL(PARSE$(sBF, 3))
    bytestruct.G = VAL(PARSE$(sBF, 4))
    bytestruct.B = VAL(PARSE$(sBF, 5))
    LSET result = bytestruct
    FUNCTION = result.longval
END FUNCTION

FUNCTION zSkinAuthor(BYVAL sAuthor AS STRING) AS STRING
    STATIC sWasAuthor AS STRING
    IF LEN(sAuthor) THEN sWasAuthor = sAuthor
    FUNCTION = sWasAuthor
END FUNCTION
'// Return the SKIN Author's name
FUNCTION SK_AUTHOR() AS STRING
    FUNCTION = zSkinAuthor("")
END FUNCTION

FUNCTION zCXSYSICON(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zCYSYSICON(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return ICON's location
SUB zGetSysIconXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zCXSYSICON(0, 0)
    y = zCYSYSICON(0, 0)
END SUB

FUNCTION zCXCAPTEXT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zCYCAPTEXT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return CAPTION's location
SUB zGetCaptionXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zCXCAPTEXT(0, 0)
    y = zCYCAPTEXT(0, 0)
END SUB

FUNCTION zBTNFIXX(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zBTNFIXY(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return BUTTON's fixed border X,Y size
SUB zGetButtonFixXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zBTNFIXX(0, 0)
    y = zBTNFIXY(0, 0)
END SUB

FUNCTION zFOLDER(BYVAL sPath AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasPath AS STRING
    IF RW THEN sWasPath = sPath
    FUNCTION = sWasPath
END FUNCTION
FUNCTION SK_FOLDER() AS STRING
    FUNCTION = zFOLDER("", 0)
END FUNCTION

FUNCTION zSkinPath(BYVAL sBF AS STRING, BYVAL sExePath AS STRING) AS STRING
    sBF = PARSE$(sBF, 2): REPLACE "@PATH@" WITH sExePath IN sBF
    FUNCTION = sBF
END FUNCTION

FUNCTION zACTIVECAPTION(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_ACTIVECAPTION() AS LONG
    FUNCTION = zACTIVECAPTION(0, 0)
END FUNCTION

FUNCTION zINACTIVECAPTION(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_INACTIVECAPTION() AS LONG
    FUNCTION = zINACTIVECAPTION(0,0)
END FUNCTION

FUNCTION zTEXTCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_TEXTCOLOR() AS LONG
    FUNCTION = zTEXTCOLOR(0,0)
END FUNCTION

FUNCTION zBTNTEXTCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_BTNTEXTCOLOR() AS LONG
    FUNCTION = zBTNTEXTCOLOR(0,0)
END FUNCTION

FUNCTION zPOPMENUTEXT(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_POPMENUTEXT() AS LONG
    FUNCTION = zPOPMENUTEXT(0,0)
END FUNCTION

FUNCTION zPOPMENUHILITE(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_POPMENUHILITE() AS LONG
    FUNCTION = zPOPMENUHILITE(0,0)
END FUNCTION

FUNCTION zACTIVEMENUBAR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_ACTIVEMENUBAR() AS LONG
    FUNCTION = zACTIVEMENUBAR(0,0)
END FUNCTION

FUNCTION zINACTIVEMENUBAR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_INACTIVEMENUBAR() AS LONG
    FUNCTION = zINACTIVEMENUBAR(0,0)
END FUNCTION

FUNCTION zCAPTIONFONT(BYVAL sCaptionFont AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasFont AS STRING
    IF RW THEN sWasFont = sCaptionFont
    FUNCTION = sWasFont
END FUNCTION
FUNCTION SK_CAPTIONFONT() AS STRING
    FUNCTION = zCAPTIONFONT("", 0)
END FUNCTION

FUNCTION zCAPTIONFONTHEIGHT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG
    FUNCTION = zCAPTIONFONTHEIGHT(0,0)
END FUNCTION

FUNCTION zPUSHBUTFONTSIZE(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_PUSHBUTFONTSIZE() AS LONG
    FUNCTION = zPUSHBUTFONTSIZE(0,0)
END FUNCTION

FUNCTION zICONSIZE(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_ICONSIZE() AS LONG
    FUNCTION = zICONSIZE(0,0)
END FUNCTION

FUNCTION zTRACKHICOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_TRACKHICOLOR() AS LONG
    FUNCTION = zTRACKHICOLOR(0,0)
END FUNCTION

FUNCTION zPAINT_BORDER(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_PAINT_BORDER() AS LONG
    FUNCTION = zPAINT_BORDER(0,0)
END FUNCTION

FUNCTION zPAINT_BACKGROUND(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_PAINT_BACKGROUND() AS LONG
    FUNCTION = zPAINT_BACKGROUND(0,0)
END FUNCTION
